
Application: gvSIG desktop - gvSIG bugs #4578
SpatiaLite: No native library is found for os.name=Windows and os.arch=amd64
07/26/2017 06:15 PM - Antonio Falciano

Status: Closed % Done: 0%
Priority: Normal Spent time: 0.00 hour
Assignee: Cesar Martinez Izquierdo
Category: Database
Target version: 2.4.0-2847 (rev. org.gvsig.desktop-2.0.216)
Severity: Major Add-on version:
gvSIG version: 2.4.0 Add-on build:
gvSIG build: 2829 Add-on resolve version:
Operative System: Windows Add-on resolve build:
Keywords: Proyecto:
Has patch: Hito:
Add-on name: Unknown
Description

It's not possible to connect to a SpatiaLite db using the JDBC driver in Windows os, because the native DLLs are not assembled into
spatialite-jdbc-4.3.0a.jar:

INFO 523164 AWT-EventQueue-0 org.gvsig.geodb.vectorialdb.wizard.WizardDB - Error while getting table names: Can't
perform operation 'ListTablesOperation'.
java.lang.RuntimeException: Can't perform operation 'ListTablesOperation'.
    at
org.gvsig.fmap.dal.store.jdbc2.spi.operations.AbstractConnectionOperation.perform(AbstractConnectionOperation.java:45)
    at org.gvsig.fmap.dal.store.jdbc2.spi.JDBCServerExplorerBase.list(JDBCServerExplorerBase.java:143)
    at org.gvsig.geodb.vectorialdb.wizard.WizardVectorialDB.getTableList(WizardVectorialDB.java:101)
    at org.gvsig.geodb.vectorialdb.wizard.WizardDB.updateTableList(WizardDB.java:458)
    at org.gvsig.geodb.vectorialdb.wizard.WizardDB$2.run(WizardDB.java:399)
    at java.awt.event.InvocationEvent.dispatch(Unknown Source)
    at java.awt.EventQueue.dispatchEventImpl(Unknown Source)
    at java.awt.EventQueue.access$500(Unknown Source)
    at java.awt.EventQueue$3.run(Unknown Source)
    at java.awt.EventQueue$3.run(Unknown Source)
    at java.security.AccessController.doPrivileged(Native Method)
    at java.security.ProtectionDomain$JavaSecurityAccessImpl.doIntersectionPrivilege(Unknown Source)
    at java.awt.EventQueue.dispatchEvent(Unknown Source)
    at org.gvsig.andami.ui.AndamiEventQueue.dispatchEvent(AndamiEventQueue.java:50)
    at java.awt.EventDispatchThread.pumpOneEventForFilters(Unknown Source)
    at java.awt.EventDispatchThread.pumpEventsForFilter(Unknown Source)
    at java.awt.EventDispatchThread.pumpEventsForFilter(Unknown Source)
    at java.awt.WaitDispatchSupport$2.run(Unknown Source)
    at java.awt.WaitDispatchSupport$4.run(Unknown Source)
    at java.awt.WaitDispatchSupport$4.run(Unknown Source)
    at java.security.AccessController.doPrivileged(Native Method)
    at java.awt.WaitDispatchSupport.enter(Unknown Source)
    at java.awt.Dialog.show(Unknown Source)
    at java.awt.Component.show(Unknown Source)
    at java.awt.Component.setVisible(Unknown Source)
    at java.awt.Window.setVisible(Unknown Source)
    at java.awt.Dialog.setVisible(Unknown Source)
    at org.gvsig.coreplugin.mdiManager.NewSkin.addJDialog(NewSkin.java:680)
    at org.gvsig.coreplugin.mdiManager.NewSkin.addWindow(NewSkin.java:289)
    at org.gvsig.app.extension.AddLayer.doAddLayers(AddLayer.java:317)
    at org.gvsig.app.extension.AddLayer.execute(AddLayer.java:226)
    at org.gvsig.andami.plugins.ExtensionHelper.execute(ExtensionHelper.java:58)
    at org.gvsig.andami.actioninfo.impl.DefaultActionInfo.execute(DefaultActionInfo.java:329)
    at
org.gvsig.app.project.documents.view.toc.AbstractActionInfoAdapterToTocContextMenuAction.execute(AbstractActionInfoAdapterToTocContextMenuAction.java:74)
    at org.gvsig.app.project.documents.view.toc.AbstractTocContextMenuAction.execute(AbstractTocContextMenuAction.java:63)
    at org.gvsig.app.project.documents.view.toc.gui.FPopupMenu$MenuItem.actionPerformed(FPopupMenu.java:248)
    at javax.swing.AbstractButton.fireActionPerformed(Unknown Source)
    at javax.swing.AbstractButton$Handler.actionPerformed(Unknown Source)
    at javax.swing.DefaultButtonModel.fireActionPerformed(Unknown Source)
    at javax.swing.DefaultButtonModel.setPressed(Unknown Source)
    at javax.swing.AbstractButton.doClick(Unknown Source)
    at javax.swing.plaf.basic.BasicMenuItemUI.doClick(Unknown Source)
    at javax.swing.plaf.basic.BasicMenuItemUI$Handler.mouseReleased(Unknown Source)
    at java.awt.Component.processMouseEvent(Unknown Source)
    at javax.swing.JComponent.processMouseEvent(Unknown Source)
    at java.awt.Component.processEvent(Unknown Source)
    at java.awt.Container.processEvent(Unknown Source)
    at java.awt.Component.dispatchEventImpl(Unknown Source)
    at java.awt.Container.dispatchEventImpl(Unknown Source)
    at java.awt.Component.dispatchEvent(Unknown Source)
    at java.awt.LightweightDispatcher.retargetMouseEvent(Unknown Source)
    at java.awt.LightweightDispatcher.processMouseEvent(Unknown Source)
    at java.awt.LightweightDispatcher.dispatchEvent(Unknown Source)
    at java.awt.Container.dispatchEventImpl(Unknown Source)
    at java.awt.Window.dispatchEventImpl(Unknown Source)
    at java.awt.Component.dispatchEvent(Unknown Source)
    at java.awt.EventQueue.dispatchEventImpl(Unknown Source)
    at java.awt.EventQueue.access$500(Unknown Source)
    at java.awt.EventQueue$3.run(Unknown Source)
    at java.awt.EventQueue$3.run(Unknown Source)
    at java.security.AccessController.doPrivileged(Native Method)
    at java.security.ProtectionDomain$JavaSecurityAccessImpl.doIntersectionPrivilege(Unknown Source)
    at java.security.ProtectionDomain$JavaSecurityAccessImpl.doIntersectionPrivilege(Unknown Source)
    at java.awt.EventQueue$4.run(Unknown Source)
    at java.awt.EventQueue$4.run(Unknown Source)
    at java.security.AccessController.doPrivileged(Native Method)
    at java.security.ProtectionDomain$JavaSecurityAccessImpl.doIntersectionPrivilege(Unknown Source)
    at java.awt.EventQueue.dispatchEvent(Unknown Source)
    at org.gvsig.andami.ui.AndamiEventQueue.dispatchEvent(AndamiEventQueue.java:50)
    at java.awt.EventDispatchThread.pumpOneEventForFilters(Unknown Source)
    at java.awt.E
pterToTocContextMenuAction.java:74)
    at
org.gvsig.app.project.documents.view.toc.AbstractTocContextMenuAction.execute(AbstractTocContextMenuAction.java:63)
    at org.gvsig.app.project.documents.view.toc.gui.FPopupMenu$MenuItem.actionPerformed(FPopupMenu.java:248)
    at javax.swing.AbstractButton.fireActionPerformed(Unknown Source)
    at javax.swing.AbstractButton$Handler.actionPerformed(Unknown Source)
    at javax.swing.DefaultButtonModel.fireActionPerformed(Unknown Source)
    at javax.swing.DefaultButtonModel.setPressed(Unknown Source)
    at javax.swing.AbstractButton.doClick(Unknown Source)
    at javax.swing.plaf.basic.BasicMenuItemUI.doClick(Unknown Source)
    at javax.swing.plaf.basic.BasicMenuItemUI$Handler.mouseReleased(Unknown Source)
    at java.awt.Component.processMouseEvent(Unknown Source)
    at javax.swing.JComponent.processMouseEvent(Unknown Source)
    at java.awt.Component.processEvent(Unknown Source)
    at java.awt.Container.processEvent(Unknown Source)
    at java.awt.Component.dispatchEventImpl(Unknown Source)
    at java.awt.Container.dispatchEventImpl(Unknown Source)
    at java.awt.Component.dispatchEvent(Unknown Source)
    at java.awt.LightweightDispatcher.retargetMouseEvent(Unknown Source)
    at java.awt.LightweightDispatcher.processMouseEvent(Unknown Source)
    at java.awt.LightweightDispatcher.dispatchEvent(Unknown Source)
    at java.awt.Container.dispatchEventImpl(Unknown Source)
    at java.awt.Window.dispatchEventImpl(Unknown Source)
    at java.awt.Component.dispatchEvent(Unknown Source)
    at java.awt.EventQueue.dispatchEventImpl(Unknown Source)
    at java.awt.EventQueue.access$500(Unknown Source)
    at java.awt.EventQueue$3.run(Unknown Source)
    at java.awt.EventQueue$3.run(Unknown Source)
    at java.security.AccessController.doPrivileged(Native Method)
    at java.security.ProtectionDomain$JavaSecurityAccessImpl.doIntersectionPrivilege(Unknown Source)
    at java.security.ProtectionDomain$JavaSecurityAccessImpl.doIntersectionPrivilege(Unknown Source)
    at java.awt.EventQueue$4.run(Unknown Source)
    at java.awt.EventQueue$4.run(Unknown Source)
    at java.security.AccessController.doPrivileged(Native Method)
    at java.security.ProtectionDomain$JavaSecurityAccessImpl.doIntersectionPrivilege(Unknown Source)
    at java.awt.EventQueue.dispatchEvent(Unknown Source)
    at org.gvsig.andami.ui.AndamiEventQueue.dispatchEvent(AndamiEventQueue.java:50)
    at java.awt.EventDispatchThread.pumpOneEventForFilters(Unknown Source)
    at java.awt.EventDispatchThread.pumpEventsForFilter(Unknown Source)
    at java.awt.EventDispatchThread.pumpEventsForHierarchy(Unknown Source)
    at java.awt.EventDispatchThread.pumpEvents(Unknown Source)
    at java.awt.EventDispatchThread.pumpEvents(Unknown Source)
    at java.awt.EventDispatchThread.run(Unknown Source)
Caused by: org.gvsig.fmap.dal.resource.exception.AccessResourceException: Error while atemp to access resource
'SpatiaLite'.
    at org.gvsig.spatialite.dal.SpatiaLiteHelper.getConnection(SpatiaLiteHelper.java:169)
    at
org.gvsig.fmap.dal.store.jdbc2.spi.operations.AbstractConnectionOperation.getConnection(AbstractConnectionOperation.java:51)
    at org.gvsig.fmap.dal.store.jdbc2.spi.operations.AbstractConnectionOperation.perform_operation(AbstractConnectionOperation.java:81)
    at org.gvsig.fmap.dal.store.jdbc2.spi.operations.AbstractConnectionOperation.perform(AbstractConnectionOperation.java:41)
    ... 74 more
Caused by: org.apache.commons.dbcp.SQLNestedException: Cannot create PoolableConnectionFactory (Error opening connection)
    at org.apache.commons.dbcp.BasicDataSource.createDataSource(BasicDataSource.java:1225)
    at org.apache.commons.dbcp.BasicDataSource.getConnection(BasicDataSource.java:880)
    at org.gvsig.spatialite.dal.SpatiaLiteHelper$ConnectionProvider.getConnection(SpatiaLiteHelper.java:91)
    at org.gvsig.spatialite.dal.SpatiaLiteHelper.getConnection(SpatiaLiteHelper.java:165)
    ... 77 more
Caused by: java.sql.SQLException: Error opening connection
    at org.spatialite.core.CoreConnection.open(CoreConnection.java:213)
    at org.spatialite.core.CoreConnection.<init>(CoreConnection.java:74)
    at org.spatialite.jdbc3.JDBC3Connection.<init>(JDBC3Connection.java:24)
    at org.spatialite.jdbc4.JDBC4Connection.<init>(JDBC4Connection.java:23)
    at org.spatialite.SQLiteConnection.<init>(SQLiteConnection.java:45)
    at org.spatialite.JDBC.createConnection(JDBC.java:114)
    at org.spatialite.JDBC.connect(JDBC.java:88)
    at org.apache.commons.dbcp.DriverConnectionFactory.createConnection(DriverConnectionFactory.java:38)
    at org.apache.commons.dbcp.PoolableConnectionFactory.makeObject(PoolableConnectionFactory.java:294)
    at org.apache.commons.dbcp.BasicDataSource.validateConnectionFactory(BasicDataSource.java:1247)
    at org.apache.commons.dbcp.BasicDataSource.createDataSource(BasicDataSource.java:1221)
    ... 80 more
Caused by: java.lang.Exception: No native library is found for os.name=Windows and os.arch=amd64
    at org.spatialite.SQLiteJDBCLoader.loadSQLiteNativeLibrary(SQLiteJDBCLoader.java:266)
    at org.spatialite.SQLiteJDBCLoader.initialize(SQLiteJDBCLoader.java:65)
    at org.spatialite.core.NativeDB.load(NativeDB.java:53)
    at org.spatialite.core.CoreConnection.open(CoreConnection.java:209)
    ... 90 more
    at
    ... 74 more
    at org.spatialite.core.CoreConnection.open(CoreConnection.java:209)
    ... 90 more

Related issues:
Related to Application: gvSIG desktop - gvSIG feature requests # 4765: Binari... Closed 12/07/2017

Associated revisions
Revision 43730 - 01/20/2018 08:52 PM - Joaquín  del Cerro Murciano

refs #4578. Modificado el gvspkg para que se puedan usar wildcards al expecificar excludes

History
#1 - 12/11/2017 08:08 AM - Joaquín  del Cerro Murciano
- Related to gvSIG feature requests #4765: Binarios de Spatialite para Linux/Win 64 y 32bits added

#2 - 12/13/2017 01:58 PM - Joaquín  del Cerro Murciano
- Target version changed from 2.4.0-2850-final (rev. org.gvsig.desktop-2.0.220) to 2.4.0-2846 (rev. org.gvsig.desktop-2.0.215)
- Assignee set to Cesar Martinez Izquierdo
- Status changed from New to Fixed

#3 - 01/03/2018 05:44 PM - Antonio Falciano
- Target version changed from 2.4.0-2846 (rev. org.gvsig.desktop-2.0.215) to 2.4.0-2850-final (rev. org.gvsig.desktop-2.0.220)
- Status changed from Fixed to New

The issue is still there in build 2846.

#4 - 01/15/2018 07:47 PM - Joaquín  del Cerro Murciano
En el build 2846 de windows se estan incluyendo dos plugins de spatialite.
    -  1.0.18.21 (generico para todas las plataformas)
    -  1.0.19.22 (para windows).

El 1.0.18.21 es la version que habia en builds anteriores y el 1.0.19.22 la nueva version. 
Si se selecciona instalacion tipica se instalan los dos, quedando instalado el plugin viejo.
Si en la instalacion avanzada desmarcamos el viejo, ya instala el nuevo.

El nuevo falla al intentar abrir una BBDD de spatialite con el error:

 WARN 1456863 [AWT-EventQueue-0] (SpatiaLiteHelper.java:162) - C:\datos\geodata\test1-country.sqlite).
org.sqlite.SQLiteException: [SQLITE_ERROR] SQL error or missing database (No se puede encontrar el m¾dulo especificado.
)
        at org.sqlite.core.DB.newSQLException(DB.java:909)
        at org.sqlite.core.DB.newSQLException(DB.java:921)
        at org.sqlite.core.DB.execute(DB.java:825)

Mirando el gvsig-launcher.log se ve:

INFO launch ./cygcheck.exe
"C:/datos/apps/gvSIG-desktop/gvSIG-desktop-2.4.0-2846/gvSIG/extensiones/org.gvsig.spatialite.app.mainplugin/native/mod_spatialite.dll" 
C:\datos\apps\gvSIG-desktop\gvSIG-desktop-2.4.0-2846\gvSIG\extensiones\org.gvsig.spatialite.app.mainplugin\native\mod_spatialite.dll
  C:\datos\apps\gvSIG-desktop\gvSIG-desktop-2.4.0-2846\gvSIG\extensiones\org.gvsig.gdal.app.mainplugin\gdal\bin\zlib1.dll
    C:\Windows\system32\MSVCR120.dll
      C:\Windows\system32\KERNEL32.dll
        C:\Windows\system32\api-ms-win-core-rtlsupport-l1-2-0.dll
        C:\Windows\system32\ntdll.dll
        C:\Windows\system32\KERNELBASE.dll
          C:\Windows\system32\api-ms-win-core-apiquery-l1-1-0.dll
        C:\Windows\system32\api-ms-win-core-processthreads-l1-1-2.dll
        C:\Windows\system32\api-ms-win-core-registry-l1-1-0.dll
        C:\Windows\system32\api-ms-win-core-heap-l1-2-0.dll
        C:\Windows\system32\api-ms-win-core-memory-l1-1-2.dll
        C:\Windows\system32\api-ms-win-core-handle-l1-1-0.dll
        C:\Windows\system32\api-ms-win-core-synch-l1-2-0.dll
        C:\Windows\system32\api-ms-win-core-file-l1-2-1.dll
        C:\Windows\system32\api-ms-win-core-delayload-l1-1-1.dll
        C:\Windows\system32\api-ms-win-core-io-l1-1-1.dll
        C:\Windows\system32\api-ms-win-core-job-l1-1-0.dll
        C:\Windows\system32\api-ms-win-core-threadpool-legacy-l1-1-0.dll
        C:\Windows\system32\api-ms-win-core-threadpool-private-l1-1-0.dll
        C:\Windows\system32\api-ms-win-core-libraryloader-l1-2-0.dll
        C:\Windows\system32\api-ms-win-core-namedpipe-l1-2-0.dll
        C:\Windows\system32\api-ms-win-core-datetime-l1-1-1.dll
        C:\Windows\system32\api-ms-win-core-sysinfo-l1-2-1.dll
        C:\Windows\system32\api-ms-win-core-timezone-l1-1-0.dll
        C:\Windows\system32\api-ms-win-core-localization-l1-2-1.dll
        C:\Windows\system32\api-ms-win-core-processenvironment-l1-2-0.dll
        C:\Windows\system32\api-ms-win-core-string-l1-1-0.dll
        C:\Windows\system32\api-ms-win-core-debug-l1-1-1.dll
        C:\Windows\system32\api-ms-win-core-errorhandling-l1-1-1.dll
        C:\Windows\system32\api-ms-win-core-fibers-l1-1-1.dll
        C:\Windows\system32\api-ms-win-core-util-l1-1-0.dll
        C:\Windows\system32\api-ms-win-core-profile-l1-1-0.dll
        C:\Windows\system32\api-ms-win-security-base-l1-2-0.dll
        C:\Windows\system32\api-ms-win-security-appcontainer-l1-1-0.dll
        C:\Windows\system32\api-ms-win-core-comm-l1-1-0.dll
        C:\Windows\system32\api-ms-win-core-realtime-l1-1-0.dll
        C:\Windows\system32\api-ms-win-core-wow64-l1-1-0.dll
        C:\Windows\system32\api-ms-win-core-systemtopology-l1-1-0.dll
        C:\Windows\system32\api-ms-win-core-processtopology-l1-2-0.dll
        C:\Windows\system32\api-ms-win-core-namespace-l1-1-0.dll
        C:\Windows\system32\api-ms-win-core-file-l2-1-1.dll
        C:\Windows\system32\api-ms-win-core-xstate-l2-1-0.dll
        C:\Windows\system32\api-ms-win-core-localization-l2-1-0.dll
        C:\Windows\system32\api-ms-win-core-normalization-l1-1-0.dll
        C:\Windows\system32\api-ms-win-core-localization-private-l1-1-0.dll
        C:\Windows\system32\api-ms-win-core-sidebyside-l1-1-0.dll
        C:\Windows\system32\api-ms-win-core-appcompat-l1-1-1.dll
        C:\Windows\system32\api-ms-win-core-windowserrorreporting-l1-1-0.dll
        C:\Windows\system32\api-ms-win-core-console-l1-1-0.dll
        C:\Windows\system32\api-ms-win-core-console-l2-1-0.dll
        C:\Windows\system32\api-ms-win-core-psapi-l1-1-0.dll
        C:\Windows\system32\api-ms-win-core-psapi-ansi-l1-1-0.dll
        C:\Windows\system32\api-ms-win-core-psapi-obsolete-l1-1-0.dll
  C:\Windows\system32\msvcrt.dll
  C:\Windows\system32\USER32.dll
    C:\Windows\system32\api-ms-win-eventing-provider-l1-1-0.dll
    C:\Windows\system32\api-ms-win-core-string-l2-1-0.dll
    C:\Windows\system32\api-ms-win-core-heap-obsolete-l1-1-0.dll
    C:\Windows\system32\api-ms-win-core-atoms-l1-1-0.dll
    C:\Windows\system32\api-ms-win-core-string-obsolete-l1-1-0.dll
    C:\Windows\system32\api-ms-win-core-localization-obsolete-l1-2-0.dll
    C:\Windows\system32\api-ms-win-core-stringansi-l1-1-0.dll
    C:\Windows\system32\api-ms-win-core-kernel32-legacy-l1-1-1.dll
    C:\Windows\system32\api-ms-win-core-appinit-l1-1-0.dll
    C:\Windows\system32\GDI32.dll
cygcheck: track_down: could not find libfreexl-1.dll

cygcheck: track_down: could not find libgeos_c-1.dll

cygcheck: track_down: could not find libiconv-2.dll

cygcheck: track_down: could not find liblwgeom-2-3-0.dll
cygcheck: track_down: could not find libproj-9.dll

cygcheck: track_down: could not find libsqlite3-0.dll

cygcheck: track_down: could not find libxml2-2.dll

INFO launch Running autorun from plugin  org.gvsig.view3d.app

Parece que le faltan o no encuentra las siguientes librerias nativas:
    -  libfreexl-1.dll
    -  libgeos_c-1.dll
    -  libiconv-2.dll
    -  liblwgeom-2-3-0.dll
    -  libproj-9.dll
    -  libsqlite3-0.dll
    -  libxml2-2.dll

#5 - 01/15/2018 07:55 PM - Joaquín  del Cerro Murciano

Descargando:

http://www.gaia-gis.it/gaia-sins/windows-bin-amd64-test/mod_spatialite-4.4.0-RC0-win-amd64.7z

Y metiendo todos los binarios en la carpeta native del plugin, ya se abren las BBDD de spatialite.

#6 - 01/15/2018 08:55 PM - Antonio Falciano

Following Joaquin suggestions (#4578#note-5), it's finally possible to load a SpatiaLite layer and eventually apply an SQL query on it also in Windows
64bit. Instead, the so called "table fields" and "working area" are not working, just like in PostGIS (see #4582 and #4583).

#7 - 01/16/2018 09:01 AM - Cesar Martinez Izquierdo
- Status changed from New to In progress

#8 - 01/17/2018 12:36 PM - Cesar Martinez Izquierdo
- Status changed from In progress to Fixed

Fixed in SVN. The fix should be available for the next build.

#9 - 01/18/2018 03:05 PM - Joaquín  del Cerro Murciano
- Target version changed from 2.4.0-2850-final (rev. org.gvsig.desktop-2.0.220) to 2.4.0-2847 (rev. org.gvsig.desktop-2.0.216)

#10 - 01/29/2018 07:21 PM - Antonio Falciano
- Status changed from Fixed to Closed
